
package MooseX::Getopt::Parser::Long;

use Moose;

with 'MooseX::Getopt::Parser';

sub getoptions {
    my ($class, $opt_spec) = @_;

    my %options;

    my $getopt = Getopt::Long::Parser->new;
    $getopt->getoptions(\%options, @$opt_spec);
    return ( \%options, undef );
}

sub _get_getopt_spec {
    my ($class, %params) = @_;

    my ( @options, %name_to_init_arg, %options );

    foreach my $opt ( @{ $params{options} } ) {
        push @options, $opt->{opt_string};

        my $identifier = $opt->{name};
        $identifier =~ s/\W/_/g; # Getopt::Long does this to all option names

        $name_to_init_arg{$identifier} = $opt->{init_arg};
    }

    return ( \@options, \%name_to_init_arg );
}

1;
